#!/usr/bin/env python
# encoding=utf8

import argparse
import os,re,sys,subprocess,csv
reload(sys)  
sys.setdefaultencoding('utf8')

parser = argparse.ArgumentParser()
parser.add_argument('-w', metavar='out-file', type=argparse.FileType('wt'), help="writes output to file")
parser.add_argument("--autonomous", "-a",  action="store_true", help="display autonomous systems numbers instead of company names")
parser.add_argument('asnumber', metavar='as', help='the AS(es) to lookup; can be a single number (1853) or a list separated by comma (1853,1,570) ', type=str, default=sys.stdin)
parser.add_argument('--caida','-c', action='store_true', help='switch to caida style csv format')
parser.add_argument('--dataset','-d', metavar='dataset', type=argparse.FileType('r'), help='add a csv dataset of AS relations', default='asrel.txt')
parser.add_argument('--orgaset','-o', metavar='orgaset', type=argparse.FileType('r'), help='add a csv dataset of AS organizations', default='asorga.txt')
args = parser.parse_args()

def skip_comments(iterable):
	for line in iterable:
		if not line.startswith('#'):
			yield line

# function to lookup an autonomous system number to its readable name, looking it up in a csv of organizations (--orgaset)

def orgalookup(asn):
	args.orgaset.seek(0)
	if args.orgaset:
		for lineo in readerorga:
			if lineo[0] == asn:
				return str(lineo[2])
	return str(asn)

# split the input list of autonomous systems to lookup

autos = args.asnumber.split(',')

# check if its one or more than one

multi = False
if len(autos) > 1:
	multi = True

destinations=[]
listnodes=[]

# open the datasets and processes their csv files

if args.dataset:
	try:
		reader = csv.reader(
			args.dataset,
			delimiter = "|"
		)
	except IOError:
		print >>sys.stderr, "Cannot open dataset"
		raise SystemExit

if args.orgaset:
	try:
		readerorga = csv.reader(
			args.orgaset,
			delimiter = "|"
		)
	except IOError:
		print >>sys.stderr, "Cannot open dataset"
		raise SystemExit

nodes=[]
relations=[]

for autosys in autos:
	
	# resets the csv reader of the organization list to the first line

	args.orgaset.seek(0)

	#looks up the AS own organization name

	autoname=orgalookup(autosys)
	if multi:
		nodes.append(['node',autosys,autoname])
	else:
		nodes.append(['node',autosys,autoname,'0'])

	if args.dataset:
		# resets the reader of the AS relationship csv file
		args.dataset.seek(0)

		for line in reader: # for each line in the csv file
			if line[0] == autosys: # if the first element is the AS we are studying
				organame=orgalookup(line[1]) # translate to readable name
				relations.append(['relation',line[0],line[1],line[2]]) # adds a relation between the two AS described in the line

				if multi: # if there is more than one AS to search for, just adds the node
					nodes.append(['node',line[1],organame])
				else: # otherwise adds it adding if it is a peer or a node which is a 'customer'
					if line[2] == '0':
						nodes.append(['node',line[1],organame,'0'])
					else:
						nodes.append(['node',line[1],organame,'-1'])
		
		args.dataset.seek(0)
		
		for line in reader:
			if line[1] == autosys:
				organame=orgalookup(line[0])
				relations.append(['relation',line[0],line[1],line[2]])

				if multi: # if there is more than one AS to search for, just adds the node
					nodes.append(['node',line[1],organame])
				else: # otherwise adds it adding if it is a peer or a node which is a 'provider'
					if line[2] == '0':
						nodes.append(['node',line[1],organame,'0'])
					else:
						nodes.append(['node',line[1],organame,'-1'])
		

# finally prints out the list of nodes

for node in nodes:
	print '|'.join(node)

# and the list of relations

for relation in relations:
	print '|'.join(relation)
