#!/usr/bin/env python
#-*- coding:utf-8 -*-

import argparse
import csv, os, sys
reload(sys)  
sys.setdefaultencoding('utf8')

parser = argparse.ArgumentParser()
parser.add_argument('--write-','-w', metavar='out-file', type=argparse.FileType('wt'), help="writes output to file", default=sys.stdout )
parser.add_argument('--csv','-c', metavar='csvfile', type=argparse.FileType('r'), help='the input csv to make into a dotfile', default=sys.stdin)
args = parser.parse_args()

try:
	reader = csv.reader(
		args.csv,
		delimiter = "|"
	)
except IOError:
	print >>sys.stderr, "Cannot open {0}".format(filepath)
	raise SystemExit

minus=[]
zeros=[]
pluss=[]
outof=[]
relations=[]

for line in reader: ### Parses the lines in the csv input..
	if line[0] == 'node':
		if len(line)>3: 
		## if the node contains more than 3 values, the third one set its power position 
		## in relation to the main AS (-1, 0 or +1, that means if it's a customer, a peer, or a provider)
			if line[3] == '-1':
				minus.append('	'+line[1]+'[label="'+line[1]+'\n'+line[2]+'"];')
			if line[3] == '0':
				zeros.append('	'+line[1]+'[label="'+line[1]+'\n'+line[2]+'"];')
			if line[3] == '+1':
				pluss.append('	'+line[1]+'[label="'+line[1]+'\n'+line[2]+'"];')
		## otherwise just adds the node without a power relation..
		else:
			outof.append('	'+line[1]+'[label="'+line[1]+'\n'+line[2]+'"];')

			## adds the relationships in-between the nodes that have been added above
	if line[0] == 'relation':
		line = {
			"as1" : line[2],
			"as2" : line[1],
			"peer" : line[3]
		}
		if line['peer'] == '0': ## if peering relation
			relations.append(line['as1']+' -> '+line['as2']+' [dir="none"];')
		elif line['peer'] == '-1': ## or if customer/provider relation
			relations.append(line['as1']+' -> '+line['as2']+';')

## prints out the graphviz dot file

print '''digraph asmapxx {
	compound= true;
	concentrate= true;
	ranksep=equally;
	overlap = false;'''

print 'subgraph cluster_plus {'
print "\n".join(pluss)
print '}'

print 'subgraph cluster_zeros {'
print "\n".join(zeros)
print '}'

print 'subgraph cluster_minus {'
print "\n".join(minus)
print '}'

print "\n".join(outof)

print "\n".join(relations)

print '}'